from enum import IntEnum


class EventType(IntEnum):
    VIEW_CONVERSION = 1
    CLICK_CONVERSION = 2
    SERVER_TO_SERVER_CONVERSION = 3
    UPVOTE = 10
    DOWNVOTE = 11
    DOWNVOTE_UNINTERESTING = 12
    DOWNVOTE_MISLEADING = 13
    DOWNVOTE_OFFENSIVE = 14
    DOWNVOTE_REPETITIVE = 15
    DOWNVOTE_OTHER = 16
    CLOSE_AD = 17
    LIKE = 20
    SHARE = 21
    COMMENT = 22
    COMMENT_REPLY = 101
    COMMENT_UPVOTE = 102
    COMMENT_DOWNVOTE = 103
    VISIBLE = 30
    HOVER = 31
    EXPAND_DIV = 32
    VIEWABLE_IMPRESSION = 40
    SHARE_ON_FACEBOOK = 50
    SHARE_ON_TWITTER = 51
    SHARE_ON_PINTEREST = 52
    SHARE_ON_REDDIT = 53
    SHARE_ON_EMAIL = 54
    VIDEO_START = 70
    VIDEO_FIRST_QUARTILE = 71
    VIDEO_MID_POINT = 72
    VIDEO_THIRD_QUARTILE = 73
    VIDEO_COMPLETE = 74
    VIDEO_MUTE = 75
    VIDEO_UNMUTE = 76
    VIDEO_PAUSE = 77
    VIDEO_REWIND = 78
    VIDEO_RESUME = 79
    VIDEO_FULL_SCREEN = 80
    VIDEO_EXIT_FULL_SCREEN = 81
    VIDEO_EXPAND = 82
    VIDEO_COLLAPSE = 83
    VIDEO_ACCEPT_INVITATION_LINEAR = 84
    VIDEO_CLOSE_LINEAR = 85
    VIDEO_SKIP = 86
    VIDEO_PROGRESS = 87
    VIDEO_ZERO_SECONDS_VIEWED = 400
    VIDEO_ONES_SECONDS_VIEWED = 401
    VIDEO_TWO_SECONDS_VIEWED = 402
    VIDEO_THREE_SECONDS_VIEWED = 403
    VIDEO_FOUR_SECONDS_VIEWED = 404
    VIDEO_FIVE_SECONDS_VIEWED = 405
    VIDEO_SIX_SECONDS_VIEWED = 406
    VIDEO_SEVEN_SECONDS_VIEWED = 407
    VIDEO_EIGHT_SECONDS_VIEWED = 408
    VIDEO_NNINE_SECONDS_VIEWED = 409
    VIDEO_TEN_SECONDS_VIEWED = 410
    VIDEO_FIFTEEN_SECONDS_VIEWED = 415
    VIDEO_TWENTY_SECONDS_VIEWED = 420
    VIDEO_TWENTY_FIVE_SECONDS_VIEWED = 425
    VIDEO_THIRTY_SECONDS_VIEWED = 430


class RateType(IntEnum):
    FLAT = 1
    CPM = 2
    CPC = 3
    CPA_VIEW = 4
    CPA_CLICK = 5
    CPA_VIEW_AND_CLICK = 6
